/*
Local INdex maker "LIN" & "LIN-Win" (C) 1999-2013 Tatsuhiko Shoji
The sources for Local INdex maker "LIN" & "LIN-Win" are distributed under the MIT open source license
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <time.h>
#include	<windows.h>

#include	"lin.h"
#ifdef LINWIN
#include	"linwin.h"
#endif
#include	"encutil.h"

/* HTMLߊ֘A */
/* ^Oߗp */
static unsigned char istag = 0,tagbuf[256],prevbuf[3],*tagp,isattr = 0,iscomment = 0;
static int istitle;
static int taglen;

/**********************/
/* HTMLt@C͌n */
/**********************/
/* HTML̃^O */
static int parseTag(void)
{
	if (tagbuf[1] == '/'){
		/* ^CgĂIĂB */
		if (_strnicmp(tagbuf+2,"title",5) == 0){
			istitle = 0;
			terminatetitle();
			return(2);
		}
	}else{
		if (_strnicmp(tagbuf+1,"title",5) == 0){
			istitle = 1;
		}else if (_strnicmp(tagbuf+1,"html",4) == 0){	// ꉞHTMLł͂悤B
			return(1);
		}
	}
	return(0);
}

/* Gg̃^Ôobt@ɃRs[ */
static void tagcpy(int c)
{
	int i;

	if (taglen < 255){
		*tagp = c;
		tagp++;
		taglen++;
	}
	for (i = 0;i < 2;i++){  // for comment check
		prevbuf[i] = prevbuf[i+1];
	}
	prevbuf[2] = c;
}

/* (HTML)t@C̉ */
int CheckHTML(char *dir_name,char *filename)
{
	int c,c2,mode,i,check_flag,result,j,skiplen,LangType;
	FILE *fpi;
	char *fnbuf,msgbuf[300];
	char escbuf[5],isG1;

	//ErrorMessage(filename);
	if ((fnbuf = (char *)malloc(strlen(dir_name)+strlen(filename)+1)) == NULL){
		ErrorMessage("Out of memory\n");
		return(-1);
	}
	sprintf(fnbuf,"%s%s",dir_name,filename);

	fpi = fopen(fnbuf,"r");
	free(fnbuf);
	if (fpi == NULL){
		sprintf(msgbuf,"Can't open %s\n",filename);
		ErrorMessage(msgbuf);
		return(-1);
	}
	istag = 0;
	istitle = 0;
	isattr = 0;
	iscomment = 0;
	taglen = 0;
	mode = 0;
	check_flag = 0;
	isG1 = 0;
	while((c = fgetc(fpi)) != EOF){
		if (c == 0x1b){
			escbuf[0] = 0x1b;
			/* ISO-2022-JP(JIS)ǂ̊mF */
			for (j = 0;j < 4;j++){
				escbuf[j+1] = fgetc(fpi);
				if (escbuf[j+1] < 0x20){
					ungetc(escbuf[j+1],fpi);
					break;
				}
				if ((escbuf[j+1] == EOF) || (escbuf[j+1] > 0x2f)){
					break;
				}
			}
			if (j == 4){	// ۂɓǂݍ񂾂Ƃ܂Ŗ߂B
				j = 3;
			}
			LangType = chkISO_2022_JP(escbuf,&skiplen);
			if (LangType == 1){	// double byte mode
				mode = 1;
				isG1 = 0;
			}else if ((LangType == 2) || (LangType == 3)){	// single byte mode
				mode = 0;
				if (LangType == 3){
					isG1 = 1;
				}else{
					isG1 = 0;
				}
			}
			if (istitle){
				titlecpy(0x1b);
				for (i = 0;i <= j;i++){
					titlecpy(escbuf[i+1]);
				}
			}
			continue;
		}else if (c == 0x0e){	// JISpJiJn
			isG1 = 1;
		}else if (c == 0x0f){
			isG1 = 0;
		}

		if (istag){		/* ^O̒ */
			if (c == '>' && isattr == 0 && isG1 == 0){
				/* ^OI */
				tagcpy(c);
				if (iscomment){
					if (prevbuf[0] == '-' && prevbuf[1] == '-'){ /* Check comment end */
						*tagp = '\0';
						istag = 0;
#if DEBUG
						printf("%s\n",tagbuf);
#endif
					}
				}else{
					*tagp = '\0';
					istag = 0;
#if DEBUG
					printf("%s\n",tagbuf);
#endif
					result = parseTag();
					if (result){
						if (result > check_flag){
							check_flag = result;
						}
					}
				}
			}else{
				if (isG1 == 0){
					switch (c){
						case 0x22:	/* " oƂ͑lǂmF */
							if (!iscomment) {
								isattr = 1 - isattr;
							}
						break;
						case '<':	/* łȂ̂<oꍇ͍܂ł̃^OLq~XƂĔjB */
							if (!isattr){	/* lłȂ̂<oĂ */
								tagcpy('\0');
								if (istitle){
									/* ׂvf̏ꍇ */
									/* ܂ł̕obt@ɓB */
									titlecat(tagbuf);
									/* ^Oobt@Zbg */
									taglen = 0;
									tagp = tagbuf;
								}
							}
						break;
					}
				}
				tagcpy(c);
				if (taglen == 4){ /* Check comment start */
					if (tagbuf[1] == '!'){
						if (tagbuf[2] == '-' && tagbuf[3] == '-'){
							iscomment = 1;
#if DEBUG
							printf("Comment\n");
#endif
						}
					}
				}
			}
		}else{
			/* ^O̊O */
			if (mode){	// JIS2oCg[h
				if (istitle){
					titlecpy(c);
				}
				c2 = fgetc(fpi);
				if (c2 != EOF){
					if (istitle){
						titlecpy(c2);
					}
				}
			}else{	// 1oCg
				if ((c == '<') && (!isG1)){
					/* ^OJn */
					istag = 1;
					iscomment = 0;
					isattr = 0;
					taglen = 0;
					tagp = tagbuf;
					tagcpy(c);
				} else if (istitle){
					titlecpy(c);
				}
			}
		}
	}
	fclose(fpi);

//	if (check_flag == 1){
		/* HTMLł͂邪 title Gg͌Ȃ */
		// bm_make(dir,filename);	// dȂ̂Ńt@Co͂B
//	}

	return(check_flag);

}

