/*
Local INdex maker "LIN" & "LIN-Win" (C) 1999-2013 Tatsuhiko Shoji
The sources for Local INdex maker "LIN" & "LIN-Win" are distributed under the MIT open source license
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <time.h>
#include	<wchar.h>
#include	<windows.h>

#include	"lin.h"
#include	"encutil.h"
#include	"mhtml.h"
#ifdef LINWIN
#include	"linwin.h"
#endif

/* #define DEBUG 1 */

/* t@CXg֘A */
struct bmList *bm_top,*bm_end,*bm_base;
WIN32_FIND_DATA info_buf;

/* ^Cg͗pobt@ */
static unsigned char titlebuf[1024];
static unsigned char *titlep;
static char titleSPflag;
static int titlelen;	/* ^Cg̕ */
static int refMode;	/* 0:QƕϊȂ(HTML) 1:Qƕϊ */

int volatile isStop = 0;	// 1̏ꍇfꂽB

/* IvVݒ */
char dir[DIRBUF];
char subdir = -1;
char dispreverse = -1;
char dirlink = -1;
char ie5 = -1;
char Mozilla = -1;
char sorttype = -1;
char HTMLtype = -1;
char hideDataDir = -1;
char *outfile = NULL;
char *indextitle = NULL;
char out_fname = -1;
char out_time = -1;
char out_size = -1;
char recSearch = -1;
char absLink = -1;
char exclude = -1;
char other = -1;
char *stylesheet = NULL;
char topStyle = -1;
static int dirLevel = 0;

/******************/
/* R[h֘A */
/******************/
#ifdef __LCC__
int     strncmpi(s,t,n)
char    *s, *t;
int n;
{
    for (; tolower(*s) == tolower(*t) && n; s++, t++ ,n-- ){
    	if (*s == 0){
    		return(0);
    	}
    }

	if (n){
		return((int)tolower(*s) - (int)tolower(*t));
	}else{
		return(0);
	}

}
#endif

/* ̖targetŎ񂩂ǂH */
char *strendstr(char *str,char *target)
{
	char *p;
	int slen,tlen;

	slen = strlen(str);
	tlen = strlen(target);
	if (slen < tlen){
		return(NULL);
	}

	/* 123456 */

	p = str + (slen - tlen);
	if (strcmp(p,target) == 0){
		return(p);
	}else{
		return(NULL);
	}
}

/********************/
/* obt@֘A */
/********************/
void _titleadd(int c)
{
	if (titlelen < 1023){
		*titlep = (unsigned char)c;
		titlep++;
		titlelen++;
	}
}

/* titleGg̓eobt@ɃRs[ */
void titlecpy(int c)
{
	/* ^Cg擪̃Xy[XJbgB(1.30.2) Ń^Cg̃\[g肫ꂢɕԁB */
	if (titleSPflag){
		if (isspace(c)){
			return;
		}else{
			titleSPflag = 0;
		}
	}

	if (refMode){
		/* ̒ǉBQƂɕϊꍇA&Qƕϊ邩&͒PƂ
		ǉB̌ŕQƂǉB*/
		switch(c){
			case '<':
				_titleadd('&');
				titlecat("lt;");
				break;
			case '>':
				_titleadd('&');
				titlecat("gt;");
				break;
			case ' ':
				_titleadd('&');
				titlecat("nbsp;");
				break;
			case '&':
				_titleadd('&');
				titlecat("amp;");
				break;
			case '\"':
				_titleadd('&');
				titlecat("quot;");
				break;
			default:
				_titleadd(c);
				break;
		}
	}else{
		_titleadd(c);
	}

}

void titlecat(char *s)
{
	while(*s){
		titlecpy(*s);
		s++;
	}
}

void inittitlebuf(void)
{
	titlep = titlebuf;
	*titlep = '\0';
	titlelen = 0;
}

/* ^Cgobt@̏̕I[ */
void terminatetitle(void)
{
	*titlep = '\0';
}

/****************/
/* HTMLo͊֘A */
/****************/
/* t@CHTMLt@Cɏo */
void filenameput(struct dir_config *dir,struct bmList *item,FILE *fp)
{
	char *filename,*buf,*p,indexfile[256],kf;
	HANDLE fd;
	int len,search_sub;
	WIN32_FIND_DATA find_buf;

	filename = item->f_info.cFileName;

	if (dir->absLink){
		len = strlen(filename) + strlen(dir->name);
		if ((buf = (char *)malloc(len+1)) != NULL){
			sprintf(buf,"%s%s",dir->name,filename);
			p = buf;
		}else{
			p = filename;
		}
	}else{
		p = filename;
	}

	kf = 0;

	/* No͂B */
	fprintf(fp,"<a class=\"link\" href=\"");
	if ((dir->absLink) && (buf != NULL)){
		fprintf(fp,"file:///");
	}
	while(*p){
		/* file:p̕ϊsȂo͂B */
		switch (*p){
			case ':':
				fprintf(fp,"|");
				kf = 0;
			break;
			case '\\':
				if (kf){
					fprintf(fp,"\\");
					kf = 0;
				}else{
					fprintf(fp,"/");
				}
			break;
			case '#':
			case ' ':
				fprintf(fp,"%%%02x",*p);
				kf = 0;
			break;
			default:
				if (kf){
					kf = 0;
				}else{
					if (isSJIS(*p)){
						kf = 1;
					}else{
						kf = 0;
					}
				}
				fprintf(fp,"%c",*p);
			break;
		}
		p++;
	}
	if (dir->absLink){
		if (buf != NULL){
			free(buf);
		}
	}

	/* TufBNgo͏ */
	if (item->f_info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){ /* Local Indexfile link */
		if (dir->dirlink){ /* TufBNg̃CfbNXt@C */
			len = strlen(filename) + strlen(dir->name) + 1 + strlen(dir->outfile) + 10;
			if ((buf = (char *)malloc(sizeof(char) * len)) != NULL){
				/* TufBNgLINCFG.INIɏ񂪂邩ǂ? */
				sprintf(buf,"%s%s\\LINCFG.INI",dir->name,filename);

				search_sub = 1;
				search_sub = GetPrivateProfileInt("LINConfig",ENABLE_SEARCH,1,buf);

				GetPrivateProfileString("LINConfig","IndexFile","\0",indexfile,256,buf);

				if ((search_sub) && (dir->recSearch)){	// ċA[h
					if ((strcmp(filename,".")) && (strcmp(filename,".."))){
						sprintf(buf,"%s%s\\",dir->name,filename);
						dirLevel++;
						main2(buf,dir,NULL);	// ݒp[hōċAIɃTufBNgB
						dirLevel--;
					}
				}

				if (strlen(indexfile)){	/* LINCFG.INIgp */
						fprintf(fp,"/%s",indexfile);
				}else{
					/* LINftHgCfbNXt@C */
					sprintf(buf,"%s%s\\%s",dir->name,filename,dir->outfile);
					// find_buf.attrib = _A_NORMAL;
					// strcpy(find_buf.cFileName,buf);

					if ((fd = FindFirstFile(buf,&find_buf)) != INVALID_HANDLE_VALUE){
						fprintf(fp,"/%s",dir->outfile);
						CloseHandle(fd);
					}else{
						/* index.html */
						sprintf(buf,"%s%s\\index.html",dir->name,filename);
						// find_buf.attrib = _A_NORMAL;
						// strcpy(find_buf.cFileName,buf);
						if ((fd = FindFirstFile(buf,&find_buf)) != INVALID_HANDLE_VALUE ){
							fprintf(fp,"/index.html");
							CloseHandle(fd);
						}
					}
				}
				free(buf);
			}
		}
	}

	fprintf(fp,"\"");
	switch (dir->HTMLtype){
		case INDEX_TYPE_FRAME:	/* t[p */
			if (item->f_info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){	/* TufBNg̒g̓TufBNgɔC */
				fprintf(fp," target=\"_top\"");
			}else{
				fprintf(fp," target=\"main\"");	/* t@C̓t@Cpt[ */
			}
		break;
		case INDEX_TYPE_WINDOW:	/* ʃEChE\ */
			if (!(item->f_info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
				fprintf(fp," target=\"LIN\"");	/* t@C̓t@Cpt[ */
			}
		break;
	}
	fprintf(fp,">%s</a>",item->name);
}

/**
 * fBNgMozilla̐̂ǂׂB
 *
 * @param basedir fBNgĂpX
 * @param dirname fBNg
 * @return 1:MozillafBNg 0:MozillafBNgł͂ȂB
 */
int isMozillaDirectory(char *basedir,char *dirname)
{
	HANDLE fd;
	char *p,*find;
	WIN32_FIND_DATA fileinfo;

	/* Mozilla̕t _files.htm?t@Cۑt@CB */
	p = (char *)malloc(_MAX_PATH);
	if (p == NULL){
		return 0;
	}
	strcpy(p,basedir);
	strcat(p,dirname);
	
	find = strendstr(p,"_files");
	if (find == NULL){
		free(p);
		return 0;
	}
	strcpy(find,".htm?");

	/* FindFirstFileŕۑt@CTB */
	memset(&fileinfo,0x00,sizeof(WIN32_FIND_DATA));
	if ((fd = FindFirstFile(p,&fileinfo)) == INVALID_HANDLE_VALUE){
		free(p);
		return 0;
	}

	CloseHandle(fd);
	free(p);
	return 1;

}

/**
 * SYSTEMTIME\̂̓e\pɐ`B
 *
 * @param buf `ꂽ񂪓obt@
 * @param systemTime `ΏۂSYSTEMTIME
 */
void makeDisplayTime(char *buf,SYSTEMTIME *systemTime)
{
	sprintf(buf,"%04d/%02d/%02d %02d:%02d:%02d",
		systemTime->wYear,
		systemTime->wMonth,
		systemTime->wDay,
		systemTime->wHour,
		systemTime->wMinute,
		systemTime->wSecond);
}

/**
 * e`ŃACȅo
 *
 * @param dir fBNg̏o͐ݒ
 * @param item fBNgʃXg
 * @param fp CfbNXt@C̃t@C|C^
 */
void multiput(struct dir_config *dir,struct bmList *item,FILE *fp)
{

	// struct tm *t;
	char *p;
	char buf[MAX_PATH];
	FILETIME *fileTime;
	SYSTEMTIME systemTime;
	FILETIME localTime;
	char timeBuf[32];
	unsigned long long size;

	// t = localtime(&item->f_info.time_write);
	fileTime = &item->f_info.ftLastWriteTime;
	FileTimeToLocalFileTime(fileTime,&localTime);
	FileTimeToSystemTime(&localTime,&systemTime);
	makeDisplayTime(timeBuf,&systemTime);
	size = item->f_info.nFileSizeHigh;
	size <<= 32;
	size = size | item->f_info.nFileSizeLow;

	strcpy(buf,dir->name);
	strcat(buf,item->f_info.cFileName);

	if (dir->ie5){ /* Check IE5 generate directory */
		if (item->f_info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			p = strendstr(item->f_info.cFileName,".files");
			if (p != NULL){
				if (dir->hideDataDir) {
					SetFileAttributes(
						buf,item->f_info.dwFileAttributes | FILE_ATTRIBUTE_HIDDEN);
				}
				return;
			}
		}
	}
	// Check Mozilla generated directory
	if (dir->Mozilla){
		if (item->f_info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
			if (isMozillaDirectory(dir->name,item->f_info.cFileName)){
				if (dir->hideDataDir) {
					SetFileAttributes(
						buf,item->f_info.dwFileAttributes | FILE_ATTRIBUTE_HIDDEN);
				}
				return;
			}
		}
	}

	switch(dir->HTMLtype){
		case INDEX_TYPE_NORMAL:
			fprintf(fp,"<p class=\"item\">\n");
			fprintf(fp,"<span class=\"title\">");
			filenameput(dir,item,fp);
			fprintf(fp,"</span>");
			fprintf(fp,"<br>\n");
			if (dir->out_fname){
				fprintf(fp,"<span class=\"filename\">%s</span> ",item->f_info.cFileName);
			}
			if (dir->out_time){
				fprintf(fp,"<span class=\"filetime\">%s</span> ",timeBuf);
			}
			if (dir->out_size){
				fprintf(fp,"<span class=\"filesize\">");
				if (item->f_info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
					fprintf(fp,"&lt;dir&gt;");
				}else{
					fprintf(fp,"%I64u bytes",size);
				}
				fprintf(fp,"</span>");
			}
			fprintf(fp,"<br>\n</p>\n");
		break;
		case INDEX_TYPE_TABLE: /* Table */
			fprintf(fp,"<tr class=\"item\">\n");

			fprintf(fp,"<td class=\"title\">");
			filenameput(dir,item,fp);
			fprintf(fp,"</td>");

			if (dir->out_fname){
				fprintf(fp,"<td class=\"filename\">%s</td>",item->f_info.cFileName);
			}
			if (dir->out_time){
				fprintf(fp,"<td class=\"filetime\">%s</td>",timeBuf);
			}
			if (dir->out_size){
				if (item->f_info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
					fprintf(fp,"<td class=\"filesize\">&lt;dir&gt;</td>");
				}else{
					fprintf(fp,"<td class=\"filesize\">%I64u</td>",size);
				}
			}

			fprintf(fp,"\n</tr>\n");
		break;
		case INDEX_TYPE_FRAME: /* Frame */
		case INDEX_TYPE_WINDOW: /* Double Window */
			fprintf(fp,"<tr class=\"item\">\n");

			fprintf(fp,"<td nowrap>\n");
			fprintf(fp,"<span class=\"title\">");
			filenameput(dir,item,fp);
			fprintf(fp,"</span>");
			fprintf(fp,"<br>\n");
			if (dir->out_fname){
				fprintf(fp,"<span class=\"filename\">%s</span><br>\n",item->f_info.cFileName);
			}
			if (dir->out_time){
				fprintf(fp,"<span class=\"filetime\">%s</span><br>\n",timeBuf);
			}
			if (dir->out_size){
				fprintf(fp,"<span class=\"filesize\">");
				if (item->f_info.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
					fprintf(fp,"&lt;dir&gt;<br>\n");
				}else{
					fprintf(fp,"%I64u bytes<br>\n",size);
				}
				fprintf(fp,"</span>");
			}
			fprintf(fp,"</td>\n");

			fprintf(fp,"</tr>\n");
		break;
	}
}

/* HTML̐擪o͂B */
void put_HTMLhead(struct dir_config *dir,FILE *fp)
{
	int i;

	fprintf(fp,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">\n");
	fprintf(fp,"<html>\n");
	fprintf(fp,"<head>\n");
	fprintf(fp,"<meta http-equiv=\"Content-type\" content=\"text/html;charset=Shift_JIS\">\n");
	fprintf(fp,"<meta http-equiv=\"CONTENT-STYLE-TYPE\" content=\"text/css\">\n");

	fprintf(fp,"<link rev=\"MADE\" href=\"mailto:rxk16664@nifty.ne.jp\">\n");
	/* X^CV[g */
	if (strlen(dir->stylesheet) > 0){
		fprintf(fp,"<link rel=\"stylesheet\" type=\"text/css\" href=\"");
		if (dir->topStyle != 1){
			for (i = 0;i < dirLevel;i++){
				fprintf(fp,"../");
			}
		}
		fprintf(fp,"%s\">\n",dir->stylesheet);
	}

	fprintf(fp,"<!-- This document is generated by Local INdex maker \"LIN\". -->\n");
	fprintf(fp,"<title>%s</title>\n",dir->title);
	fprintf(fp,"</head>\n");
	fprintf(fp,"<body>\n");
	fprintf(fp,"<h1 class=\"pagetitle\">%s</h1>\n",dir->title);

	switch(dir->HTMLtype){
		case INDEX_TYPE_NORMAL:
			fprintf(fp,"<div class=\"list\">\n");
		break;
		case INDEX_TYPE_TABLE:
			fprintf(fp,"<table border=\"1\" class=\"list\">\n<tbody>\n");
			fprintf(fp,"<tr>\n");
			fprintf(fp,"<th>\n");
			fprintf(fp,"Title");
			fprintf(fp,"</th>\n");

			if (dir->out_fname){
				fprintf(fp,"<th>Filename </th>");
			}
			if (dir->out_time){
				fprintf(fp,"<th>Last Update </th>");
			}
			if (dir->out_size){
				fprintf(fp,"<th>File size </th>");
			}

			fprintf(fp,"\n</tr>\n");
		break;
		case INDEX_TYPE_FRAME:
		case INDEX_TYPE_WINDOW:
			fprintf(fp,"<table class=\"list\">\n<tbody>\n");
		break;
	}
}

/* HTML̏I̕o͂B */
void put_HTMLfoot(struct dir_config *dir,FILE *fp)
{
	switch(dir->HTMLtype){
		case INDEX_TYPE_TABLE:
		case INDEX_TYPE_FRAME:
		case INDEX_TYPE_WINDOW:
			fprintf(fp,"</tbody>\n</table>\n");
		break;
		case INDEX_TYPE_NORMAL:
			fprintf(fp,"</div>\n");
		break;
	}
	fprintf(fp,"</body>\n</html>\n");
}

/**********************/
/* ACeXg֘A */
/**********************/
/* t@CXgSo */
void bm_put(struct dir_config *dir,FILE *fp)
{
	struct bmList *now,*p;

	now = dir->top;
	while(now != NULL){
		multiput(dir,now,fp);
		p = now->next;
		now = p;
	}

}

/* t@CXgSJ */
void bm_delete(struct dir_config *dir)
{
	struct bmList *now,*p;

	now = dir->top;
	while(now != NULL){
		free(now->name);
		p = now->next;
		free(now);
		now = p;
	}
	dir->top = NULL;
	dir->current = NULL;
	dir->end = NULL;
}

/**
 * FILETIMEm̔rsB
 *
 * @param t1 1Ԗڂ̎
 * @param t2 2Ԗڂ̎
 * @return 1:t1̕ 0: -1:t2̕
 */
int timecmp(FILETIME *t1,FILETIME *t2)
{
	if (t1->dwHighDateTime > t2->dwHighDateTime) {
		return 1;
	}

	if (t1->dwHighDateTime < t2->dwHighDateTime) {
		return -1;
	}

	if (t1->dwLowDateTime > t2->dwLowDateTime) {
		return 1;
	}

	if (t1->dwLowDateTime < t2->dwLowDateTime) {
		return -1;
	}
	return 0;
}

/**
 * ACem̔r
 *
 * @param dir rݒ
 * @param p1 1Ԗڂ̃ACe
 * @param p2 2Ԗڂ̃ACe
 * @return strcmpƓ
 */
int ex_comp(struct dir_config *dir,struct bmList *p1,struct bmList *p2)
{
	int result;

	switch(dir->sorttype){
		case 1: /* Title */
			result = strcmp(p1->name,p2->name);
		break;
		case 2: /* Filename */
			result = strcmp(p1->f_info.cFileName,p2->f_info.cFileName);
		break;
		case 3: /* Time Stamp */
			result = timecmp(&p1->f_info.ftLastWriteTime,&p2->f_info.ftLastWriteTime);
		break;
		case 4: /* size */
			if ((p1->f_info.nFileSizeHigh) < (p2->f_info.nFileSizeHigh)){
				result = -1;
			}else if ((p1->f_info.nFileSizeHigh) > (p2->f_info.nFileSizeHigh)){
				result = 1;
			}

			if ((p1->f_info.nFileSizeLow) < (p2->f_info.nFileSizeLow)){
				result = -1;
			}else if ((p1->f_info.nFileSizeLow) > (p2->f_info.nFileSizeLow)){
				result = 1;
			}else{
				result = 0;
			}
		break;
		default:
			return(-1);
	}
	if (dir->reverse){
		result = 0 - result;
	}
	return(result);
}

/**
 * \[gȂACeǉ
 *
 * @param dir AvP[Vݒ
 * @param item ǉACe
 */
void bm_link(struct dir_config *dir,struct bmList *item)
{
	struct bmList *now;

	item->next = NULL;
	if (dir->top == NULL && dir->end == NULL){ /* New list make */
		dir->top = item;
		dir->end = item;
		item->prev = NULL;
		return;
	}
	now = dir->end;
	if (ex_comp(dir,now,item) < 0){
		dir->end = item;
		now->next = item;
		item->prev = now;
	}else{
		/* ou\[g̗v̂ŔrȂǉĂB */
		do{
			if (now->prev == NULL){
				item->prev = NULL;
				item->next = now;
				now->prev = item;
				dir->top = item;
				return;
			}else{
				now = now->prev;
			}
		}while(ex_comp(dir,now,item) > 0);

		item->prev = now;
		item->next = now->next;
		now->next = item;
		item->next->prev = item;
	}
}

/**
 * ACẽm
 *
 * @param dir AvP[Vݒ
 * @param str ǉACẽ^Cg
 */
void bm_make(struct dir_config *dir,unsigned char *str)
{
	struct bmList *bm;
	unsigned char *p;
	int len;

	if ((bm = (struct bmList *)malloc(sizeof(struct bmList))) == NULL){
		bm_delete(dir);
	}
	len = strlen(str);
	if (len == 0){
		p = "No name";
		len = 7;
	}else{
		p = str;
	}

	if ((bm->name = (unsigned char *)malloc(len+1)) == NULL){
		free(bm);
		bm_delete(dir);
	}else{
		strcpy(bm->name,p);
	}
	bm->f_info = info_buf;
	bm_link(dir,bm);	/* t@CǉB */

}

/** t@Cʐ */
#define FILETYPES 11
/** t@Cʔe[u */
static struct filetype t_ftype[] = {
	{".html"	,5,1},
	{".htm"		,4,1},
	{".shtm"	,5,1},
	{".shtml"	,6,1},
	{".txt"		,4,2},
	{".man"		,4,2},
	{".me"		,3,2},
	{".1st"		,4,2},
	{".pdf"		,4,3},
	{".mht"		,4,4},
	{".mhtml"	,4,4},
};

/**
 * t@C̎ރ`FbN
 *
 * @param filename t@C
 */
int checkFileType(unsigned char *filename)
{
	int len,i;
	len = strlen(filename);

	for (i = 0;i < FILETYPES;i++){
		if (len < t_ftype[i].len){
			break;
		}
		if (!strnicmp(filename + len - t_ftype[i].len,t_ftype[i].name,t_ftype[i].len)){
			return t_ftype[i].type;
		}
	}
	return 0;
}

/* ŁAt@C̎ނƂɕB */
int CheckFile(struct dir_config *dir,unsigned char *filename)
{
	unsigned char tbuf2[1024];
	int result,docType;

	// ^Cgobt@̏
	titlep = titlebuf;
	titlelen = 0;
	titleSPflag = 1;

	/* t@C̓eɉďς邽߃t@C̊gq𔻕ʂ */
	docType = checkFileType(filename);

	inittitlebuf();	/* ^Cgpobt@̏͋ʂȂ̂łōsB */
	/* ŕ */
	switch(docType){
		case 0:	/* ΏۊOt@C */
			if (dir->otherLink){	/* ΏۊOt@CɃNꍇ */
				refMode = 1;	/* Qƕϊ */
				result = CheckNULL(dir->name,filename);
			}else{
				return 0;	/*  */
			}
		break;
		case 1:	/* HTML */
			refMode = 0;	/* QƕϊȂ */
			result = CheckHTML(dir->name,filename);
		break;
		case 2:	/* eLXgt@C */
			refMode = 1;	/* Qƕϊ */
			result = CheckTXT(dir->name,filename);
		break;
		case 3:	/* Ή\t@C(ΉȂ) */
			refMode = 1;	/* Qƕϊ */
			result = CheckNULL(dir->name,filename);	/* t@Cׂ͒Č悤ɂB */
		break;
		case 4:	/* MHTML */
			refMode = 0;	/* QƕϊȂ */
			result = CheckMHTML(dir->name,filename);
		break;
		default:
			return(1);
		break;
	}
	if (result < 0){
		return(1);
	}
	// XgɐڑB
	if (titlelen){	// ^CgH
		// R[h
		if (chkUTF8(titlebuf)){
			utf8tomb(tbuf2,titlebuf,1024);
		}else if (chkjiseuc(titlebuf)){
			eucput(tbuf2,titlebuf);
		}else if (chkjisms(titlebuf)){
			jisput(tbuf2,titlebuf);
		}else{
			jisput(tbuf2,titlebuf);
		}
		bm_make(dir,tbuf2);	// t@Co͂B
	}else{
		bm_make(dir,filename);	// dȂ̂Ńt@Co͂B
	}
	return(0);
}

/********************/
/* t@C֘A */
/********************/
int search_files(struct dir_config *dir,char *mask,int mode)
{
	HANDLE fd;
	char msgbuf[300];
	int result;

	if ((fd = FindFirstFile(mask,&info_buf)) == INVALID_HANDLE_VALUE){
		sprintf(msgbuf,"%s file Not found\n",mask);
		ErrorMessage(msgbuf);
		return(2);
	}

	result = 0;
	sprintf(msgbuf,"Frame.%s",dir->outfile);	// CfbNXt@C̃t@CƂ̔ʗp
	do{

#ifdef LINWIN
		if (isStop){	// fꂽꍇ̓[v𔲂B
			result = 1;
			break;
		}
		Sleep(0);
#endif

		if (mode){
			if (info_buf.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
				bm_make(dir,info_buf.cFileName);
			}
		}else{
			if ((info_buf.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0){
				if (dir->exclude){
					if (!strcmp(info_buf.cFileName,dir->outfile)){
						continue;
					}
					if (!strcmp(info_buf.cFileName,msgbuf)){
						continue;
					}
				}
				CheckFile(dir,info_buf.cFileName);
			}
		}
	}while(FindNextFile(fd,&info_buf));
	CloseHandle(fd);

	return(result);
}

/**
 * t[t@C𐶐B
 *
 * @param dir AvP[Vݒ
 */
void frameHTML(struct dir_config *dir)
{
	FILE *fpo;
	int len,len2;
	char *fnbuf,*fnbuf2;

	len2 = strlen(dir->outfile);

	if (len2){
		len = strlen(dir->name) + strlen(dir->outfile) + 16;

		if ((fnbuf = (char *)malloc(len)) == NULL){
			ErrorMessage("Out of memory\n");
			return;
		}
		sprintf(fnbuf,"%s%s",dir->name,dir->outfile);

		fpo = fopen(fnbuf,"w");

		if ( fpo == NULL){
			return;
		}
	}else{
		fpo = stdout;
	}

	fprintf(fpo,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Frameset//EN\">\n");
	fprintf(fpo,"<html>\n");
	fprintf(fpo,"<head>\n");
	fprintf(fpo,"<meta http-equiv=\"Content-type\" content=\"text/html;charset=Shift_JIS\">\n");
	fprintf(fpo,"<!-- This document is generated by Local INdex maker \"LIN\". -->\n");
	fprintf(fpo,"<title>%s</title>\n",dir->title);
	fprintf(fpo,"</head>\n");
	fprintf(fpo,"<frameset cols=\"30%%,*\">\n");
	fprintf(fpo,"<frame src=\"Frame.%s\" name=\"Index\">\n",dir->outfile);
	fprintf(fpo,"<frame name=\"main\" src=\"\">\n",fnbuf);
	fprintf(fpo,"<noframes>\n");
	fprintf(fpo,"<body>\n");
	fprintf(fpo,"<h1>For non frame supported browsers</h1>\n");
	fprintf(fpo,"<p>\n");

	if (len2){
		len = strlen(dir->outfile) + 1 + 6;

		if ((fnbuf2 = (char *)malloc(len)) == NULL){
			ErrorMessage("Out of memory\n");
			free(fnbuf);
			fclose(fpo);
			return;
		}
		sprintf(fnbuf2,"Frame.%s",dir->outfile);
		fprintf(fpo,"<a href=\"",fnbuf2);
		fprintf(fpo,"%s",fnbuf2);
		free(fnbuf2);
	}

	fprintf(fpo,"\"");
	fprintf(fpo,">%s</a><br>\n",dir->title);
	free(fnbuf);

	fprintf(fpo,"</p>\n");
	fprintf(fpo,"</body>\n");
	fprintf(fpo,"</noframes>\n");
	fprintf(fpo,"</frameset>\n");
	fprintf(fpo,"</html>\n");

	if (dir->outfile != NULL){
		fclose(fpo);
	}
}

/**
 * fBNgIvṼftHglݒ肷
 *
 * @param dir AvP[Vݒ
 */
void dir_inidefault(struct dir_config *dir)
{
	strcpy(dir->title,"Local Index page");
	dir->sorttype = 0;
	dir->HTMLtype = 0;
	dir->subdir = 0;
	dir->reverse = 0;
	dir->dirlink = 0;
	dir->ie5 = 0;
	dir->Mozilla = 0;
	dir->hideDataDir = 0;
	strcpy(dir->outfile,"");
	strcpy(dir->stylesheet,"");
	dir->out_fname = 1;
	dir->out_size = 1;
	dir->out_time = 1;
	dir->recSearch = 0;
	dir->absLink = 0;
	dir->exclude = 0;
	dir->otherLink = 0;

}

/**
 * INIt@Cݒǂ
 *
 * @param dir AvP[Vݒ
 * @param target_dir ݒt@C݂̑fBNg
 * @param filename ݒt@C
 */
void read_inifile(struct dir_config *dir,char *target_dir,char *filename)
{
	unsigned char buf[256],buf2[256];
	int result;

	sprintf(buf,"%s%s",target_dir,filename);

	GetPrivateProfileString("LINConfig","Target","\0",buf2,256,buf);
	if (strlen(buf2)){
		strncpy(dir->name,buf2,256);
	}

	GetPrivateProfileString("LINConfig","IndexFileName","\0",buf2,256,buf);
	if (strlen(buf2)){
		strncpy(dir->outfile,buf2,256);
	}

	GetPrivateProfileString("LINConfig","IndexFileTitle","\0",buf2,256,buf);
	if (strlen(buf2)){
		strncpy(dir->title,buf2,256);
	}

	GetPrivateProfileString("LINConfig","CSSFile","\0",buf2,256,buf);
	if (strlen(buf2)){
		strncpy(dir->stylesheet,buf2,256);
	}

	GetPrivateProfileString("LINConfig","Sorttype","\0",buf2,256,buf);
	if (strlen(buf2)){
		result = atoi(buf2);
		if (result < 0 || result > 4){ /* 0:Nothing 1:Title 2:Filename 3:time stamp */
			dir->sorttype = 0;
		}else{
			dir->sorttype = result;
		}
	}

	GetPrivateProfileString("LINConfig","HTMLtype","\0",buf2,256,buf);
	if (strlen(buf2)){
		result = atoi(buf2);
		if (result < 0 || result > 3){
			dir->HTMLtype = 0;
		}else{
			dir->HTMLtype = result;
		}
	}

	GetPrivateProfileString("LINConfig","Subdir","\0",buf2,256,buf);
	/* result = GetPrivateProfileInt("LINConfig","Subdir",-1,buf); */
	if (strlen(buf2)){
		result = atoi(buf2);
		dir->subdir = result;
	}

	GetPrivateProfileString("LINConfig","SortReverse","\0",buf2,256,buf);
	/* result = GetPrivateProfileInt("LINConfig","SortReverse",-1,buf); */
	if (strlen(buf2)){
		result = atoi(buf2);
		dir->reverse = result;
	}

	GetPrivateProfileString("LINConfig","IgnoreIE5Dir","\0",buf2,256,buf);
	/* result = GetPrivateProfileInt("LINConfig","IgnoreIE5Dir",-1,buf); */
	if (strlen(buf2)){
		result = atoi(buf2);
		dir->ie5 = result;
	}

	GetPrivateProfileString("LINConfig","IgnoreMozDir","\0",buf2,256,buf);
	/* result = GetPrivateProfileInt("LINConfig","IgnoreIE5Dir",-1,buf); */
	if (strlen(buf2)){
		result = atoi(buf2);
		dir->Mozilla = result;
	}

	GetPrivateProfileString("LINConfig","HideDataDir","\0",buf2,256,buf);
	if (strlen(buf2)){
		result = atoi(buf2);
		dir->hideDataDir = result;
	}

	result = GetPrivateProfileInt("LINConfig","SubDirIndexLink",-1,buf);
	if (result != -1){
		dir->dirlink = result;
	}

	result = GetPrivateProfileInt("LINConfig","OutputFilename",-1,buf);
	if (result != -1){
		dir->out_fname = result;
	}

	result = GetPrivateProfileInt("LINConfig","OutputTime",-1,buf);
	if (result != -1){
		dir->out_time = result;
	}

	result = GetPrivateProfileInt("LINConfig","OutputSize",-1,buf);
	if (result != -1){
		dir->out_size = result;
	}

	result = GetPrivateProfileInt("LINConfig","RecSearch",-1,buf);
	if (result != -1){
		dir->recSearch = result;
	}

	result = GetPrivateProfileInt("LINConfig","AbsolutePath",-1,buf);
	if (result != -1){
		dir->absLink = result;
	}

	result = GetPrivateProfileInt("LINConfig","ExcludeLocalIndexFile",-1,buf);
	if (result != -1){
		dir->exclude = result;
	}

	result = GetPrivateProfileInt("LINConfig","UseIndividualCSS",-1,buf);
	if (result != -1){
		dir->topStyle = result;
	}

	GetPrivateProfileString("LINConfig","OtherFileLink","\0",buf2,256,buf);
	/* result = GetPrivateProfileInt("LINConfig","IgnoreIE5Dir",-1,buf); */
	if (strlen(buf2)){
		result = atoi(buf2);
		dir->otherLink = result;
	}

}

/**
 * st@ĈfBNgݒǂݍ܂B
 *
 * @param dir AvP[Vݒ
 */
void dir_readDefault(struct dir_config *dir)
{
	HMODULE handle;

	char drive[_MAX_DRIVE];
	char base_dir[_MAX_DIR];
	char Fulldir[_MAX_PATH];
	char Fullpath[_MAX_PATH];

	handle = GetModuleHandle(NULL);
	GetModuleFileName(handle,Fullpath,_MAX_PATH);
	_splitpath(Fullpath,drive,base_dir,NULL,NULL);
	sprintf(Fulldir,"%s%s",drive,base_dir);

#ifdef LINWIN
	read_inifile(dir,Fulldir,"LINWDEF.INI");
#else
	read_inifile(dir,Fulldir,"LINDEF.INI");
#endif

}

/**
 * R}hC/_CAO w̃IvVZbg
 *
 * @param dir AvP[Vݒ
 */
void set_comoption(struct dir_config *dir)
{
	if (subdir > -1){
		dir->subdir = subdir;
	}
	if (dispreverse > -1){
		dir->reverse = dispreverse;
	}
	if (dirlink > -1){
		dir->dirlink = dirlink;
	}
	if (ie5 > -1){
		dir->ie5 = ie5;
	}
	if (Mozilla > -1){
		dir->Mozilla = Mozilla;
	}
	if (hideDataDir > -1){
		dir->hideDataDir = hideDataDir;
	}
	if (other > -1){
		dir->otherLink = other;
	}
	if (sorttype > -1){
		dir->sorttype = sorttype;
	}
	if (HTMLtype > -1){
		dir->HTMLtype = HTMLtype;
	}
	if (out_fname > -1){
		dir->out_fname = out_fname;
	}
	if (out_time > -1){
		dir->out_time = out_time;
	}
	if (out_size > -1){
		dir->out_size = out_size;
	}
	if (recSearch > -1){
		dir->recSearch = recSearch;
	}
	if (absLink > -1){
		dir->absLink = absLink;
	}
	if (exclude > -1){
		dir->exclude = exclude;
	}
	if (outfile != NULL){
		strcpy(dir->outfile,outfile);
	}
	if (indextitle != NULL){
		strcpy(dir->title,indextitle);
	}
	if (stylesheet != NULL){
		strcpy(dir->stylesheet,stylesheet);
	}
	if (topStyle == 1){
		dir->topStyle = 1;
	}
}

/* fBNg */
int main2(unsigned char *dir_name,struct dir_config *org,struct dir_config *conf)
{
	FILE *fpo;
	struct dir_config *dir;
	char *findmask,*fnbuf;
	int len,result;

	result = 0;
	dir = (struct dir_config *)malloc(sizeof(struct dir_config));
	if (dir == NULL){
		return(1);
	}

	if (org != NULL){
		// efBNg̐ݒp
		memcpy(dir,org,sizeof(struct dir_config));
	}else{
		// ftHgl̐ݒ(AR\[ł̂ݗL)
		dir_inidefault(dir);
		dir_readDefault(dir);
	}

	read_inifile(dir,dir_name,"LINCFG.INI");	// efBNgLINCFG.INIǂݍ
	strcpy(dir->name,dir_name);					// ^[QbgfBNg̏Zbg

	if (org == NULL){
		if (conf == NULL){
			// CUIł͍ċAďo
			// TufBNgłȂꍇ̓R}hC_CAOŐݒ肵IvVZbg
			set_comoption(dir);
		}else{
			// fthł͑Sݒ肪łĂ̂ŏ㏑B
			memcpy(dir,conf,sizeof(struct dir_config));
		}
	}

	dir->top = NULL;
	dir->current = NULL;
	dir->end = NULL;

	/* pt@C쐬 */
	len = strlen(dir_name);
	findmask = (char *)malloc(len + 4);
	if (findmask == NULL){
		free(dir);
		return(1);
	}else{
		strcpy(findmask,dir->name);
		strcat(findmask,"*.*");
	}

	/* o̓t@C쐬 */
	len = strlen(dir->outfile);
	if (len){
		len = strlen(dir->name) + strlen(dir->outfile) + 1;

		if (dir->HTMLtype == INDEX_TYPE_FRAME){
			len = len + 16;
		}

		if ((fnbuf = (char *)malloc(len)) == NULL){
			ErrorMessage("Out of memory\n");
			free(dir);
			return(1);
		}
		strcpy(fnbuf,dir->name);
		if (dir->HTMLtype == INDEX_TYPE_FRAME){
			strcat(fnbuf,"Frame.");
		}
		strcat(fnbuf,dir->outfile);

		fpo = fopen(fnbuf,"w");

		if ( fpo == NULL){
			free(fnbuf);
			free(dir);
			return(1);
		}
		free(fnbuf);
	}else{
		fpo = stdout;
	}

	/* fBNg */
	put_HTMLhead(dir,fpo);

	if (dir->subdir){
		// info_buf.attrib = _A_SUBDIR;
		result = search_files(dir,findmask,1);	/* .HTM matches *.htm and *.html */
		bm_put(dir,fpo);
		bm_delete(dir);
	}

	// info_buf.attrib = _A_NORMAL;
	if (!result){
		result = search_files(dir,findmask,0);	/* .HTM matches *.htm and *.html */
		bm_put(dir,fpo);
		bm_delete(dir);
	}

	put_HTMLfoot(dir,fpo);

	if (strlen(dir->outfile)){
		fclose(fpo);
		if (dir->HTMLtype == INDEX_TYPE_FRAME){ /* R\[o͂̎Ƀt[̐^oĂ̑ÕCfbNXt@C̏o͂ɂĂ܂̂łɈړ */
			frameHTML(dir);
		}
	}

	free(findmask);
	free(dir);
	return(result);
}
